<?php

	/**
	* 14/12/2016
	* @author Francis
	*/
	namespace PAE\Util;
	
	use Zeedhi\Framework\DependencyInjection\InstanceManager;
	class SQLLogger implements \Doctrine\DBAL\Logging\SQLLogger {

	protected $queryLogger;
	protected $sql;
	protected $params;
	protected $types;
	protected $startTime;
	protected $endTime;
	protected $logRoute = false;

	public function __construct(QueryLogger $queryLogger) {
		$this->queryLogger = $queryLogger;
	}

	public function startQuery($sql, array $params = null, array $types = null) {
		$this->sql = $sql;
		$this->params = $params;
		$this->types = $types;
		$this->startTime = new \DateTime();
	}

	public function stopQuery() {

		$this->endTime = new \DateTime();
		$duration = $this->startTime->diff($this->endTime);
		$queryProperties = array(
			'sql' => $this->sql,
			'params' => $this->params,
			'types' => $this->types,
			'startTime' => $this->startTime->format('d/m/Y H:i:s'),
			'endTime' => $this->endTime->format('d/m/Y H:i:s'),
			'duration' => $duration->format("%Y years, %m months, %d days, %H hours, %i minutes, %s seconds")
		);
		$this->queryLogger->createLogFile($queryProperties, $this->logRoute);

	}

	public function setLogRoute($logRoute) {
		$this->logRoute = $logRoute;
	}

}