CREATE OR REPLACE PROCEDURE IMPORT_PRODFORNCOMP
                     (P_CDFILCENTCMP   IN ITMAPURPREC.CDCENTITMAP%TYPE,
                      P_NRAPURPREC     IN ITMAPURPREC.NRSEQITMAP%TYPE,
                      P_CDPRODINI      IN PRODUTO.CDARVPROD%TYPE DEFAULT NULL,
                      P_CDPRODFIN      IN PRODUTO.CDARVPROD%TYPE DEFAULT NULL,
                      P_DTENTREGA      IN ITMAPURPREC.DTENTRAPUT%TYPE,
                      P_CDCOMPRADOR    IN VARCHAR2,
                      P_CDOPERADOR     IN VARCHAR2,
                      P_CDFILIAL       IN VARCHAR2,
                      P_CDFORNECED     IN FORNECEDOR.CDFORNECED%TYPE,
                      P_CDCUSTO        IN VARCHAR2,
                      P_LISTAPRECO     IN VARCHAR2,
                      P_ROWSAFFECT     OUT VARCHAR2)
IS
 V_IDCONSPRSOL       PARASUPRI.IDCONSPRSOL%TYPE;
 V_IDSEPAFIMP        VARCHAR2(1);
 V_IDUTISTATCOT      VARCHAR2(1);
 V_IDUTILCONSSOLIOL  VARCHAR2(1);
 V_IDUTLPRCMPATIVO   VARCHAR2(1);
 V_IDUTLMARPREFOL    PARASUPRI.IDUTLMARPREFOL%TYPE;
 V_CDMARCA_PADRAO    PARASUPRI.CDMARCA%TYPE;
 V_IDUTLPRARVOLCMP   PARASUPRI.IDUTLPRARVOLCMP%TYPE;
 V_IDFUNCAOFILICMPOL PARASUPRI.IDUTLPRARVOLCMP%TYPE;
 V_IDARREDCMPAMENOS  VARCHAR2(1);
 V_IDUTQTDISPGERAL   VARCHAR2(1);
 V_EMITENTE          VARCHAR2(4);
 V_CDEMPRESA         EMPRESA.CDEMPRESA%TYPE;
 V_CONCKEY           VARCHAR2(200);
 V_IDTIPEMIT         VARCHAR2(1);
 V_DSPZOPGTCONC      VARCHAR2(2000);
 V_IDPRODWEB         AUTOFORNE.IDAFPRODWEB%TYPE;
 V_CDFILIOPELOG      VARCHAR2(2000);
 V_VRCUSTO           FLOAT;

 BEGIN
   P_ROWSAFFECT := 'N';
   SELECT
      NVL(MAX(IDCONSPRSOL), 'N'),
      NVL(MAX(IDSEPAFIMP), 'N'),
      NVL(MAX(IDUTISTATCOT), 'N'),
      NVL(MAX(IDUTILCONSSOLIOL), 'N'),
      NVL(MAX(IDUTQTDISPGERAL), 'N'),
      NVL(MAX(IDUTLMARPREFOL), 'N'),
      NVL(MAX(CDMARCA), V_CDMARCA_PADRAO),
      NVL(MAX(IDUTLPRARVOLCMP), 'N'),
      NVL(MAX(IDUTLPRCMPATIVO), 'N'),
      NVL(MAX(IDARREDCMPAMENOS), 'N')
   INTO
      V_IDCONSPRSOL,      /* Considerar somente Produto Solicitado para Cotao e AF Automtica */
      V_IDSEPAFIMP,       /*Gera AF's Separadas de Acordo com o Imposto*/
      V_IDUTISTATCOT,     /*Utiliza Status na Cotao*/
      V_IDUTILCONSSOLIOL, /*Utiliza consolidao de solicitao de compras para o OL*/
      V_IDUTQTDISPGERAL,  /*Utiliza quantidade disponvel para a escolha dos melhores preos*/
      V_IDUTLMARPREFOL,   /*Utiliza Marca Preferencial no Lanamento de Pedidos OL*/
      V_CDMARCA_PADRAO,
      V_IDUTLPRARVOLCMP,
      V_IDUTLPRCMPATIVO,  /* Desconsidera embalagem utilizada para compra na gerao da AF do OL */
      V_IDARREDCMPAMENOS  /* Grava quantidade a comprar com valor arredondado para menos */
   FROM
      PARASUPRI
   WHERE
      CDFILIAL = P_CDFILCENTCMP;
   INSERT
     INTO APURPRECO (CDFILCENTCMP, NRAPURPREC, CDCOMPRADOR, DTINIAPUPREC,
          DTFINAPUPREC, IDSITAPUPREC, DTAPURPREC, CDOPERADOR, CDFILLANC,
          DSGRUPFILIAPUR, CDPRODINICAPUR, CDPRODFINAAPUR, IDCONSOLAPUEFET)
   VALUES (P_CDFILCENTCMP, P_NRAPURPREC, P_CDCOMPRADOR, P_DTENTREGA,
           P_DTENTREGA, '1', SYSDATE, P_CDOPERADOR, P_CDFILCENTCMP,
           '', P_CDPRODINI, P_CDPRODFIN, 'N');

   FOR C_GRAVA IN (SELECT CDFILIAL, CDREGIAO, CDPRODUTO, DTPROGENTR, QTSOLIPROD,
                          CDMARCA, VRCUSTO, NRAPURPREC, NRCOLEPRECO, VRFATOCONV, CDFORNECED,
                          CDTIPCOB, CDFORMPGTO, IDUTDIAPGTFO, IDTPFORPGTFO, IDTPFRETFORN,
                          NRPARCPGTOFO, VRPEDESCFORN, NRDIAPGFIXFO
                     FROM (SELECT I.CDFILIAL, FILIAL.NMFILIAL,
                                  FILIAL.CDREGIAO, PRODUTO.CDPRODUTO, TO_DATE(TRUNC(P_DTENTREGA)) DTPROGENTR,
                                  0 QTSOLIPROD, PRODUTO.NMPRODUTO, PRODUTO.CDARVPROD, PRODUTO.SGUNIDADE, MARCPRODCOMP.CDMARCA,
                                  (CASE
                                     WHEN P_LISTAPRECO = 'S'
                                     THEN 0
                                     ELSE CUSTO_PRODUTO(I.CDFILIAL, PRODUTO.CDPRODESTO, P_CDCUSTO, SYSDATE, SYSDATE)
                                  END) * PRODUTO.VRFATOCONV AS VRCUSTO, P_NRAPURPREC NRAPURPREC, '9999999999' NRCOLEPRECO,
                                  PRODUTO.VRFATOCONV, PF.CDFORNECED, CDTIPCOB, CDFORMPGTO, IDUTDIAPGTFO,
                                  IDTPFORPGTFO, IDTPFRETFORN, NRPARCPGTOFO, VRPEDESCFORN, NRDIAPGFIXFO
                             FROM PRODFILI I, PRODUTO, FILIAL, MARCPRODCOMP,
                                  (SELECT P.CDPRODCOMPL, P.CDFORNECED, CDTIPCOB, CDFORMPGTO,
                                          IDUTDIAPGTFO, IDTPFORPGTFO, IDTPFRETFORN, NRPARCPGTOFO,
                                          VRPEDESCFORN, NRDIAPGFIXFO, CDQUALIF, DTVALQUALIF, IDFORNAUTO
                                     FROM PRODFORNCOMP P, FORNECEDOR
                                    WHERE (P_CDFORNECED = P.CDFORNECED)
                                      AND P.CDFORNECED   = FORNECEDOR.CDFORNECED) PF, PARASUPRI
                    WHERE ((INSTR(P_CDFILIAL, I.CDFILIAL ) > 0) OR (P_CDFILIAL = 'T'))
                      AND I.CDPRODUTO    = PRODUTO.CDPRODUTO
                      AND (PF.CDPRODCOMPL = PRODUTO.CDPRODUTO)
                      AND NVL(I.IDPRODATIV, 'I') = 'A'
                      AND (FILIAL.CDFILIAL = I.CDFILIAL)
                      AND NVL(FILIAL.IDFUNCAOFILI, 'S') <> 'O'
                      AND NVL(FILIAL.IDCNTRRESC, 'S') = 'N'
                      AND FILIAL.CDREGIAO IS NOT NULL
                      AND NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL)  = P_CDFILCENTCMP
                      AND (PARASUPRI.CDFILIAL = P_CDFILCENTCMP)
                      AND PRODUTO.CDPRODUTO = MARCPRODCOMP.CDPRMARCOMPL
                      AND ((PRODUTO.CDARVPROD BETWEEN P_CDPRODINI AND P_CDPRODFIN) OR (NVL(P_CDPRODFIN, 'T') = 'T'))
                      AND EXISTS (SELECT PRODCOMP.CDPRODUTO
                                    FROM PRODCOMP, PRODUTO PR
                                   WHERE PRODCOMP.CDPRODUTO  = PR.CDPRODUTO
                                     AND PRODCOMP.CDOPERADOR = P_CDCOMPRADOR
                                     AND PRODUTO.CDARVPROD LIKE PR.CDARVPROD || '%')
                       AND NOT EXISTS (SELECT REFOREG.CDREGIAO
                                         FROM REFOREG
                                        WHERE REFOREG.CDREGIAO   = FILIAL.CDREGIAO
                                          AND REFOREG.CDFORNECED = P_CDFORNECED)
                       AND NOT EXISTS (SELECT REFORFIL.CDFILIAL
                                         FROM REFORFIL
                                        WHERE REFORFIL.CDFILIAL   = FILIAL.CDFILIAL
                                          AND REFORFIL.CDPERIENTR IS NULL
                                          AND REFORFIL.CDFORNECED = P_CDFORNECED )
                       AND NOT EXISTS (SELECT QFOPRODFORN.CDPRODUTO
                                         FROM QFOPRODFORN
                                        WHERE PARASUPRI.CDFILIAL     = P_CDFILCENTCMP
                                          AND (QFOPRODFORN.CDPRODUTO = PRODUTO.CDPRODUTO)
                                          AND (QFOPRODFORN.CDFORNECED = P_CDFORNECED)
                                          AND ((QFOPRODFORN.IDFORNAPROV = 'N'
                                          AND QFOPRODFORN.IDFORNAUTOR = 'N')
                                           OR ((QFOPRODFORN.IDFORNAPROV = 'S')
                                          AND ((PARASUPRI.IDULTIDTVALQ = 'M'
                                          AND P_DTENTREGA > LAST_DAY(QFOPRODFORN.DTVALPRFORN))
                                           OR (PARASUPRI.IDULTIDTVALQ = 'D'
                                           AND P_DTENTREGA > QFOPRODFORN.DTVALPRFORN)) ) ))
                       AND NOT EXISTS (SELECT QFOMARPROD.CDMARCA
                                         FROM QFOMARPROD
                                        WHERE (PARASUPRI.CDFILIAL = P_CDFILCENTCMP)
                                          AND (QFOMARPROD.CDPRODUTO = PRODUTO.CDPRODUTO)
                                          AND (QFOMARPROD.CDMARCA   = MARCPRODCOMP.CDMARCA)
                                          AND ((QFOMARPROD.IDAPRMARPRO = 'N'
                                          AND QFOMARPROD.IDAUTMARPRO = 'N')
                                           OR ((QFOMARPROD.IDAPRMARPRO = 'S')
                                          AND ((PARASUPRI.IDULTIDTVALQ = 'M'
                                          AND P_DTENTREGA > LAST_DAY(QFOMARPROD.DTVALAPROVA))
                                           OR (PARASUPRI.IDULTIDTVALQ = 'D'
                                          AND P_DTENTREGA > QFOMARPROD.DTVALAPROVA)) ) ))
                       AND EXISTS (SELECT QFOMARPROD.CDMARCA
                                     FROM QFOMARPROD
                                    WHERE QFOMARPROD.CDPRODUTO = PRODUTO.CDPRODUTO
                                      AND QFOMARPROD.CDMARCA   = MARCPRODCOMP.CDMARCA
                                    UNION
                                   SELECT PARASUPRI.CDMARCA
                                     FROM PARASUPRI
                                    WHERE PARASUPRI.CDFILIAL     = P_CDFILCENTCMP
                                      AND (PARASUPRI.IDMARSEMQUA = 'N' OR PARASUPRI.IDMARSEMQUA IS NULL))
                       AND NOT EXISTS (SELECT QUALIFICACAO.CDQUALIF
                                         FROM QUALIFICACAO
                                        WHERE (PF.CDQUALIF       = QUALIFICACAO.CDQUALIF)
                                          AND (PARASUPRI.CDFILIAL        = P_CDFILCENTCMP)
                                          AND (PF.IDFORNAUTO     = 'N')
                                          AND ((QUALIFICACAO.IDPERCOTCMP = '2')
                                           OR ((PARASUPRI.IDULTIDTVALQ  = 'D'
                                          AND P_DTENTREGA > PF.DTVALQUALIF)
                                           OR (PARASUPRI.IDULTIDTVALQ = 'M'
                                          AND P_DTENTREGA > LAST_DAY(PF.DTVALQUALIF)))))))
   LOOP
      V_EMITENTE  := EMITENTE(C_GRAVA.CDFILIAL, C_GRAVA.CDPRODUTO, C_GRAVA.CDFORNECED);
      V_CDEMPRESA := SUBSTR(V_EMITENTE, 3, 2);
      V_CONCKEY   := V_CONCKEY||C_GRAVA.CDFILIAL|| C_GRAVA.CDFORNECED ||SUBSTR(V_EMITENTE, 3, 2)||
                     C_GRAVA.IDTPFORPGTFO ||
                     C_GRAVA.CDTIPCOB     || C_GRAVA.IDTPFRETFORN  ||
                     C_GRAVA.CDFORMPGTO   || C_GRAVA.NRPARCPGTOFO ||
                     C_GRAVA.NRDIAPGFIXFO || C_GRAVA.IDUTDIAPGTFO ||SUBSTR(V_EMITENTE, 1, 1);
      V_IDTIPEMIT := SUBSTR(V_EMITENTE, 1, 1);
      V_DSPZOPGTCONC := CONCAT_PZO_PAGTO (C_GRAVA.CDFILIAL,   C_GRAVA.NRCOLEPRECO,
                                          C_GRAVA.CDFORNECED, C_GRAVA.CDPRODUTO,
                                          C_GRAVA.CDMARCA,    C_GRAVA.CDREGIAO);


      V_IDPRODWEB    := 'N';
      V_CDFILIOPELOG := 'X';
      V_VRCUSTO      := C_GRAVA.VRCUSTO;
      IF P_LISTAPRECO = 'S' THEN
         SELECT NVL(MIN(VRPRECUNIITM), 0)
           INTO V_VRCUSTO
           FROM ITEMCOLE, FILIAL, PRODUTO
          WHERE ITEMCOLE.CDFILIAL     = P_CDFILCENTCMP
            AND ITEMCOLE.CDFORNECED   = C_GRAVA.CDFORNECED
            AND FILIAL.CDFILIAL       = C_GRAVA.CDFILIAL
            AND C_GRAVA.DTPROGENTR BETWEEN ITEMCOLE.DTINIVALITM AND ITEMCOLE.DTFINVALITM
            AND PRODUTO.CDPRODUTO   = C_GRAVA.CDPRODUTO
            AND ITEMCOLE.CDREGIAO   = FILIAL.CDREGIAO
            AND ITEMCOLE.CDPRODUTO  = PRODUTO.CDPRODUTO
            AND ITEMCOLE.VRPRECUNIITM > 0;
      END IF;
      INSERT INTO ITMAPURPREC
      (CDCENTITMAP,  NRSEQITMAP,   CDFILIAP,
       DTENTRAPUT,   CDPRODITMAP,  NRCOLEITMAP,
       CDFORNITMAP,  CDREGITMAP,   CDMARCITMAP,
       QTSOLACOMP,   QTACOMP,      CDTIPCOBAP,
       CDEMPRESAAP,  CDFORMPGTOAP, IDULTDIAPGTAF,
       CONCKEYAP,    IDTPFORPGTAP, IDTIPOEMITAP,
       IDTIPOFRETAP, NRPARCPGTOAP, VRPRECUNIAP,
       VRPERDESIAP,  NRDIAPGFIAP, DSPZOPGTCOAP,
       VRPRECECOAP,  VRPRECONPIAP, IDITMLISPRAP)
      VALUES(P_CDFILCENTCMP,
             P_NRAPURPREC,
             C_GRAVA.CDFILIAL,
             C_GRAVA.DTPROGENTR,
             C_GRAVA.CDPRODUTO,
             C_GRAVA.NRCOLEPRECO,
             C_GRAVA.CDFORNECED,
             C_GRAVA.CDREGIAO,
             C_GRAVA.CDMARCA,
             0,
             0,
             C_GRAVA.CDTIPCOB,
             V_CDEMPRESA,
             C_GRAVA.CDFORMPGTO,
             C_GRAVA.IDUTDIAPGTFO,
             V_CONCKEY||V_IDPRODWEB||V_CDFILIOPELOG,
             C_GRAVA.IDTPFORPGTFO,
             V_IDTIPEMIT,
             C_GRAVA.IDTPFRETFORN,
             C_GRAVA.NRPARCPGTOFO,
             V_VRCUSTO,
             C_GRAVA.VRPEDESCFORN,
             C_GRAVA.NRDIAPGFIXFO,
             V_DSPZOPGTCONC,
             V_VRCUSTO,
             V_VRCUSTO,
             'N');
      V_CONCKEY := '';
      IF SQL%ROWCOUNT > 0 THEN
         P_ROWSAFFECT := 'S';
      END IF;

   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('IMPORT_PRODFORNCOMP','6.49.011'); END;
/
